/* Graphic functions
 * Written 2002,2003 by Christian Nowak <chnowak@web.de>
 * http://chn.roarvgm.com/
 */

#include "gfx.h"
#include "fontraw.h"

#define SINVAL(a) sinetab[(a)&4095]
#define COSVAL(a) sinetab[((a)+1024)&4095]

u32 sinmul ( u16 angle, u16 factor )
	{
		return ((s32)(s16)factor*(s32)SINVAL(angle))>>15;
	}

u32 cosmul ( u16 angle, u16 factor )
	{
		return ((s32)(s16)factor*(s32)COSVAL(angle))>>15;
	}

void PrintChar ( u8 * dest, int x, int y, char c, u8 scol )
	{
		int dx,dy;
		u32 destofs = 0;
		u32 srcofs = 0;
		u32 mc;

		if (c=='' || c=='')
			c='A';
		else
		if (c=='' || c=='')
			c='O';
		else
		if (c=='' || c=='')
			c='U';
		else
		if (c=='')
			c='S';

		if (c<32 || c>90)
			return;

		mc = c-32;
		destofs = (y*320)+x;		

		if (mc<20)
			{
				srcofs=0;
			}
		else
		if (mc<40)
			{
				srcofs=16*320;
				mc-=20;
			} else
		if (mc<60)
			{
				srcofs=32*320;
				mc-=40;
			}
		
		srcofs+=mc*16;
		
		for (dy=0;dy<16;dy++)
			{
				for (dx=0;dx<16;dx++)
					{
						u8 d = fontraw[srcofs++];
						if (d!=0)
							dest[destofs] = d+scol;
						destofs++;
					}
				srcofs+=320-16;
				destofs+=320-16;
			}
	}

int PrintString ( u8 * dest, char * s, int x, int y, u8 scol )
	{
		int i, retval=16;
		
		i = 0;
		while (1)
			{
				if (s[i]=='\0')
					return retval;
				if (x>(320-16))
					{
						retval+=16;
						x=0;
						y+=16;
					}
				PrintChar ( dest, x, y, toupper(s[i++]), scol );
				x+=16;
			}
	}

void PrintStringCenter ( u8 * dest, char * s, int y, u8 scol )
	{
		int l = strlen ( s );
		
		PrintString ( dest, s, 160-(l*8), y, scol );
	}

void Zoom ( ZoomStr * zm )
	{
		int x,y,ofs;
		u16 xofs,yofs;
		
		yofs = zm->ypos;
		ofs=0;
		for (y=0;y<240;y++)
			{
				u16 tmp = yofs&0xff00;
				xofs = zm->xpos;
				for (x=0;x<320;x++)
					{
						zm->dest[ofs++] = zm->src[(xofs>>8) | tmp];
						xofs += zm->xscale;
					}
				yofs += zm->yscale;
			}
	}
