/* Graphic functions
 * Written 2002,2003 by Christian Nowak <chnowak@web.de>
 * http://chn.roarvgm.com/
 */

#ifndef __GFX_H__
#define __GFX_H__

#ifdef __cplusplus
extern "C" {
#endif

#include "defines.h"

extern u32 sinetab[];

typedef struct ZoomStr
	{
		u8 * src;		/* 0 */
		u8 * dest;	/* 4 */
		u16 xpos;		/* 8 */
		u16 ypos;		/* 10 */
		u16 xscale;	/* 12 */
		u16 yscale;	/* 14 */
	} ZoomStr;

u32 sinmul ( u16 angle, u16 factor );
u32 cosmul ( u16 angle, u16 factor );
void PrintChar ( u8 * dest, int x, int y, char c, u8 scol );
int PrintString ( u8 * dest, char * s, int x, int y, u8 scol );
void PrintStringCenter ( u8 * dest, char * s, int y, u8 scol );
void Zoom ( ZoomStr * zm );

#ifdef __cplusplus
}
#endif

#endif
